<?php

//extract params from get
if (isset($_GET['ip']))
	$ip = $_GET['ip'];
$port = isset($_GET['port']) ? $_GET['port'] : 36963;

//if none are set, show the form
if (empty($ip)) {
	?>
    <form action="" method="get">
    <table border="1">
        <tr><td>Server IP</td><td><input type="text" name="ip"/></td></tr>
        <tr><td>Server Port</td><td><input type="text" name="port"/></td></tr>
        <tr><td>OK</td><td><input type="submit" value="Submit" /></td></tr>
    </table>
    </form> 
	<?php
	exit;
}

//get server info
$info = CS2D::getInfo($ip, $port);

echo '<!-- pretty print of $info';
print_r($info);

echo '--><table border="1">';
foreach ($info as $index => $value)
    echo '<tr><td>' . $index . '</td><td>' . $value . '</td></tr>';
echo '</table>';

//get players info
$players = CS2D::getPlayers($ip, $port);

echo '<!-- pretty print of $players';
print_r($players);

echo '--><br><table border="1">';
echo '<tr><td>id</td><td>Name</td><td>Score</td><td>Deaths</td><td>Team</td></tr>';

foreach ($players as $index => $value) {
    echo '<tr><td>' . $index . '</td>';
    
    foreach ($value as $val)
        echo '<td>' . $val . '</td>';
    echo '</tr>';
}
echo '</table>';

//self-contained class

class CS2D {
    private static $teams = [
        'Spectator',
        'Terrorist',
        'Counter-Terrorist'
    ];
    
    public static function getInfo($ip, $port = 36963) {
        $data = array_map(function($data) {
            return explode('</td>', $data)[0];
        }, explode('<td>',
            file_get_contents('http://unrealsoftware.de/inc_pub/serverinfo.php?i=' . $ip . '&p=' . $port)));

        $sv_data = [];
        for ($i = 1; $i < sizeof($data); $i += 2)
            $sv_data[substr($data[$i], 0, -1)] = $data[$i + 1];

        return $sv_data;
    }
    
    public static function getPlayers($ip, $port = 36963) {
        $data = substr(self::server_players($ip, $port), 10);
        
        $players = [];
        $last = 0;
        for ($i = 1; $i <= 32; $i++) {
            $data = substr($data,$last);
            $userlen = self::reverse($data, 2, 2) * 2;
            
            $player_id = self::fetch_sint($data, 0);
            if ($player_id == 0)
                break;
            
            $players[$player_id] = [
                'name'   => self::hexToStr(substr($data, 4, $userlen)),
                'score'  => self::fetch_int($data, $userlen + 6),
                'deaths' => self::fetch_int($data, $userlen + 14),
                'team'   => self::$teams[intval(self::fetch_sint($data, $userlen + 4))]
            ];
            
            $last=$userlen + 22;
        }

        return $players;
    }
    
    
    private static function server_players($ip, $port = 36963) {
        $fp = @fsockopen("udp://" . $ip, $port, $errno, $errstr);
        fwrite($fp, chr(1) . chr(0) . chr(251) . chr(5));
        $str = fread($fp, 2048);
        $hex = '';
        for ($i = 0; $i < strlen($str); $i++)
            $hex .= strlen($part = dechex(ord($str[$i]))) == 1 ? '0' . $part : $part;
        
        return $hex;
    }  
    
    private static function hexToStr($hex) {
        $str = '';
        
        for ($i = 0; $i < strlen($hex) - 1; $i += 2)
            $str .= chr(hexdec($hex[$i] . $hex[$i + 1]));
        
        return utf8_encode($str);
    }    
    
    private static function reverse($data, $from, $to) {
        $hex = '';
        
        for ($i = $to; $i >= $from; $i -= 2)
            $hex .= substr($data, $i, 2);
        
        return hexdec($hex);
    }

    private static function fetch_int($data, $index) {
        return self::reverse($data, $index, $index + 4);
    }

    private static function fetch_sint($data, $index) {
        return self::reverse($data, $index, $index);
    }
    
}
